'use strict';

var ListaColaboradorController = angular.module('ListaColaboradorController', []);

ListaColaboradorController.controller('ListaColaboradorCtrl', ['$scope', '$routeParams', 'DiarioObra', 'CacheApp',
  ($scope, $routeParams, DiarioObra, CacheApp) => {

    $scope.setFuncionario = (funcionario) => {
        delete funcionario.Editar;
        funcionario.Tipo = funcionario.TipoSelecionado.Id;
        funcionario.IdFuncao = funcionario.FuncaoSelecionada.Id;
        DiarioObra.setFuncionario(funcionario,
            (data) => {
                var retorno = data.Instance[0];
                if (retorno.Codigo != 0) {
                    $scope.msgBoxAtencao("Atenção", retorno.Mensagem, null);
                }
                else {
                    funcionario.Novo = false;
                    funcionario.Id = retorno.IdFuncionario;
                    funcionario.TipoDescricao = funcionario.TipoSelecionado.Descricao;
                    funcionario.Funcao = funcionario.FuncaoSelecionada.Nome;
                }
            });
    }

    $scope.excluirFuncionario = (funcionario) => {
        $scope.msgBoxPergunta(funcionario.Nome, ' Confirma exclusão?'
        , () => {
            DiarioObra.delFuncionario(funcionario.Id,
                (data) => {
                    var idx = $scope.funcionarios.indexOf(funcionario);
                    $scope.funcionarios.splice(idx, 1);
                });
        }
        , () => {
        });
    }

    $scope.getListaFuncionario = () => {
        DiarioObra.getListaFuncionario($scope.construcao.Id,
            (data) => {
                $scope.funcionarios = data.Instance;
            });
    }

    $scope.getListaFuncao = () => {
        DiarioObra.getListaFuncao($scope.construcao.IdClienteDono,
            (data) => {
                $scope.listaFuncao = data.Instance;
            });
    }

    $scope.getHtmlEditar = () => {
        return '' +
            '<form class="form col-lg-12 col-md-12 col-sm-12 col-xs-12 center-block" name="formFuncionario">' +
            '    <div class="form-group">' +
            '       <div class="row">' +
            '           <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '	            <select class="form-control"' +
            '		            ng-model="funcionario.TipoSelecionado"' +
            '		            ng-options="tipo.Descricao for tipo in listaTipo track by tipo.Id" required>' +
            '	                <option style="display:none" value=""> Selecione o tipo </option>' +
            '	            </select>' +
            '               <div class="showMobile"> <br /> </div> ' +
            '           </div>' +
            '           <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '	            <select class="form-control"' +
            '		            ng-model="funcionario.FuncaoSelecionada"' +
            '		            ng-options="funcao.Nome for funcao in listaFuncao track by funcao.Id" required>' +
            '	                <option style="display:none" value=""> Selecione a função </option>' +
            '	            </select>' +
            '               <div class="showMobile"> <br /> </div> ' +
            '           </div>' +
            '           <div class="col-lg-5 col-md-5 col-sm-5 col-xs-12">' +
            '	            <input type="text" class="form-control" placeholder="Nome do Funcionário" maxlength="100" ng-model="funcionario.Nome" required/>' +
            '               <div class="showMobile"> <br /> </div> ' +
            '           </div>' +
            '           <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '	            <itemsalvar ng-click="!formFuncionario.$invalid && setFuncionario(funcionario)"></itemsalvar>' +
            '	            <itemcancelar ng-click="cancelarFuncionario(funcionario)"></itemcancelar>' +
            '           </div>' +
            '       </div>' +
            '    </div>' +
            '</form>';
    }

    $scope.adicionarFuncionario = () => {
        var idCount = $scope.funcionarios.length;
        $scope.funcionarios.unshift({
            Novo: true,
            Id: 0,
            IdConstrucao: $scope.construcao.Id,
            Tipo: '',
            IdFuncao: '',
            IdCount: idCount,
            Editar: $scope.getHtmlEditar()
        });
    }

    $scope.alterarFuncionario = (funcionario) => {
        funcionario.Editar = $scope.getHtmlEditar();
        funcionario.TipoSelecionado = { Id: funcionario.Tipo, Descricao: funcionario.TipoDescricao };
        funcionario.FuncaoSelecionada = { Id: funcionario.IdFuncao, Nome: funcionario.Funcao };

        funcionario.Novo = true;
    }

    $scope.cancelarFuncionario = (funcionario) => {
        if (funcionario.Id == 0) {
            var idx = $scope.funcionarios.indexOf(funcionario)
            $scope.funcionarios.splice(idx, 1);
        }
        else
            funcionario.Novo = false;
    }      

    $scope.AcessoAndroid($routeParams, (sim) => {
        $scope.AcessoMobile = sim;

        $scope.construcao = CacheApp.getConstrucao();
        var diario = CacheApp.getDiarioObra();
        $scope.Redirecionado = diario ? diario.Redirecionado : false;
        $scope.getListaFuncionario();
        $scope.getListaFuncao();
        $scope.listaTipo = [{ Id: 3, Descricao: 'Funcionário' }, { Id: 4, Descricao: 'Terceirizado' }];
    });

}]);
